# coding: utf-8

from pyspark import SparkContext

from pyspark.sql import HiveContext

from pyspark.sql import Row

from pyspark.sql.types import *

import jieba

import jieba.posseg as pseg

import json



#ʼSpark

sc = SparkContext("local", "words_cut")

sqlContext = HiveContext(sc)



#ִʺ

def map_func(r):

    # ƽ̨Զֵ

    platforms_str = u"eٴ,eⱦ,˴,˴,Ͷ,ױ"

    platforms_items = platforms_str.split(",")

    for platform in platforms_items:

        jieba.add_word(platform, 1, "pla")



    pairs = pseg.lcut(r.content)#jiebaִ

    words = map(lambda x: [x.word, x.flag], pairs)  # תΪ

    json_str = json.dumps(words)  # лΪjson

    return(r.id,json_str)



txt_df = sqlContext.sql("select * from web_data") #ҳ

rdd = txt_df.map(map_func) #÷ִʺ



df = sqlContext.createDataFrame(rdd,["id","words"]) #תΪDataframe

sqlContext.sql("create table if not exists web_words(id string,words string)") #Hive

df.insertInto("web_words",True)#ִʽHiveǾɼ¼
