# coding: utf-8

from pyspark import SparkContext

from pyspark.sql import HiveContext

from pyspark.sql import Row

from pyspark.sql.types import *

import json



sc = SparkContext("local", "platforms_analyse")

sqlContext = HiveContext(sc)



words_df = sqlContext.sql("select * from web_words")  #Hiveȡִ



#ȡעΪplaĴΪƽ̨

def get_platforms(id,words):

    platforms=[]

    for word in words:

        if word[1]=="pla":

            platforms.append((id,word[0]))

    return platforms;





#ƽ̨

def map_func(r):

    json_str = r.words

    words = json.loads(json_str)#jsonȡִ

    platforms = get_platforms(r.id,words) #ȡƽ̨

    return platforms



entitys_rdd = words_df.map(map_func) #ƽ̨



#ƽ̨

platforms_rdd = entitys_rdd.flatMap(lambda x:x) #ƽ

platforms_df = sqlContext.createDataFrame(platforms_rdd,["id","platform"]) #תΪDataframe

sqlContext.sql("create table if not exists web_platforms(id string,platform string)") #Hive

platforms_df.insertInto("web_platforms",True)#ƽ̨
