# coding: utf-8

from pyspark import SparkContext

from pyspark.sql import HiveContext

from pyspark.sql import Row

from pyspark.sql.types import *

import json



sc = SparkContext("local", "companys_analyse")

sqlContext = HiveContext(sc)



words_df = sqlContext.sql("select * from web_words") #Hiveȡִ



# ڹƥ乫˾

def get_companys(id,words):

    company_suffix_str = u"˾,ɷݹ˾,޹˾,,,"  # ˾׺

    company_suffix = set(company_suffix_str.split(","))

    companys = []

    for i in xrange(len(words)):

        word = words[i]

        #ҹ˾׺

        if word[0] in company_suffix:

            pos = i - 1

            #ǰҵ

            while (pos > -1) & (i - pos < 10):

                prefix = words[pos]

                if prefix[1] == "ns":#ҵ

                    nodes = words[pos:i + 1]

                    company = "".join(map(lambda x: x[0], nodes))

                    companys.append((id,company)) #¼ҵĹ˾

                pos = pos - 1

    return  companys



#˾Ʒ

def map_func(r):

    words = json.loads(r.words)   #jsonȡִ

    companys = get_companys(r.id,words)  #ȡ˾

    return companys



entitys_rdd = words_df.map(map_func)#ù˾Ʒ



#湫˾

companys_rdd = entitys_rdd.flatMap(lambda x:x) #ƽ

companys_df = sqlContext.createDataFrame(companys_rdd,["id","company"]) #תΪDataframe

sqlContext.sql("create table if not exists web_companys(id string,company string)") #Hiveд

companys_df.insertInto("web_companys",True) #湫˾Ǿɼ¼
