# coding: utf-8

from pyspark import SparkContext

from pyspark.sql import HiveContext

from pyspark.sql import Row

from pyspark.sql.types import *

import json



#ʼSpark

sc = SparkContext("local", "risk_analyse")

sqlContext = HiveContext(sc)



txt_df = sqlContext.sql("select id,content from web_data") #ҳ



#ڷʶ

def map_func(r):

    risk_keywords_str = u"Ƿ,Ƿ,Ҹ,޷,ӳٶҸ,,Ӫ,ʽ"

    risk_keywords = set(risk_keywords_str.split(","))

    risk_list = []

    #մʲҼ

    for word in risk_keywords:

        count = r.content.count(word)

        if (count > 0):

            risk_list.append((r.id,word, count))

    return risk_list;



rdd = txt_df.map(map_func)  #÷ʶ

risk_rdd = rdd.flatMap(lambda x:x) #ƽ



risk_df = sqlContext.createDataFrame(risk_rdd,["id","risk_word","count"]) #תΪDataframe

sqlContext.sql("create table if not exists web_risk(id string,risk_word string,count int)") #Hive

risk_df.insertInto("web_risk",True) #ƽ̨
